/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.13X */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "abimport.h"
#include "proto.h"

#include <photon/PhRender.h> 

#include "global.h"

int
button_hit( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	// determine if we have a go or a start
	if ( widget == ABW_but1 ) { // go
		animation_on = 1;
	}
	else
	if ( widget == ABW_but2 ) { // stop
		animation_on = 0;
	}

    return( Pt_CONTINUE ); 
}

void
animate_iteration()
{

	x_offset += direction;

	if ( x_offset < END_X ) {
		direction = 2;
		x_offset = END_X;
		}
	else
	if ( x_offset > BEGIN_X ) {
		direction = -2;
		x_offset = BEGIN_X;
		}
		
    PmMemStart( mc ); 

	copy_base_image(&draw_box);
	draw_text1( x_offset, y_offset );

    PmMemStop( mc ); 
    PmMemFlush( mc, image ); // get the image 

	PgDrawImagemx( (void *)(image->image + (draw_box.pos.y * image->bpl)),
                   Pg_IMAGE_DIRECT_888,
                   &draw_box.pos,
                   &draw_box.size,
                   image->bpl,                   
                   0 );
    PgFFlush( 1 );
}

/* move text in from right to left */
void 
draw_text1( int x_offset, int y_offset ) 
{ 
    PhPoint_t    textpoint; 

    // draw whatever we want to appear in the image 
	// note that our draw context is already set to mc

    PgSetFont( "helv48i" ); 
    PgSetTextColor( Pg_YELLOW ); 
    textpoint.x = x_offset; 
    textpoint.y = y_offset; 

    PgDrawText( songstring, strlen( songstring ), &textpoint, Pg_TEXT_MIDDLE ); 
} 

int
timer1( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	// we've got a timer tick ... do some animation
	if ( animation_on ) {
		animate_iteration();
	}

	return( Pt_CONTINUE );

	}


int
setup_globals( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )
{

	/* we want to find out some data

	- the global PhPoint_t pos is the origin of the background image
	      - this is determined from reading the widget
	- the global PhArea_t draw_box is the box that contains the animation
    - the values of globals x_offset and y_offset are where we will draw
      the text.
	*/


	PtArg_t arg[1];
	PhPoint_t *bgimage_24_pos;

	translation.x = 0;
	translation.y = 0;

	// find position of background widget

	PtSetArg(&arg[0], Pt_ARG_POS, &bgimage_24_pos, 0);
	PtGetResources( ABW_bgimage_24, 1, arg );

	pos.x = bgimage_24_pos->x;
	pos.y = bgimage_24_pos->y;

	strcpy( songstring,"Sing along ...");
//	strcpy( songstring,"Animated text...");; 
	animation_on = 0;

	// x_offset is defined already in the header
	y_offset = dim.h / 2;       // start at middle of vertical area 

	draw_box.pos.y  = y_offset - TEXT_HEIGHT/2;
	draw_box.pos.x  = pos.x;

	draw_box.size.h = TEXT_HEIGHT;
	draw_box.size.w = dim.w;

	direction = -2;

	return( Pt_CONTINUE );
}

